					member()


					MAP
					END

	include('ClarionTest_TestRunner.inc'),once
	include('ClarionTest_TestResult.inc'),once
	include('System_Diagnostics_Debugger.inc'),once
	!include('debuger.inc'),once

dbg                 System_Diagnostics_Debugger

ClarionTest_TestRunner.Construct                       PROCEDURE
	CODE
	self.Procedures &= new ClarionTest_ProceduresQueue
	
ClarionTest_TestRunner.Destruct                        procedure
	code
	free(self.Procedures)
	dispose(self.Procedures)

ClarionTest_TestRunner.Init	procedure(string dllname)
	CODE
	self.DllMgr &= new System_Runtime_Dll
	self.DllName = dllname
	
ClarionTest_TestRunner.Kill	procedure
	CODE
	if ~self.dllmgr &= NULL
		self.DllMgr.kill()
	end
	
	
ClarionTest_TestRunner.GetTestProcedures               procedure(*Queue q)	
ProcsQ                                                      QUEUE
ProcName                                                        cstring(200)
															end
x                                                           long
ListProcedureFound                                                   byte(false)
GetListProc string('CLARIONTEST_GETLISTOFTESTPROCEDURES')
ctProcedures                                                &ClarionTest_Procedures
lptr                                                          long
utr                                                         &ClarionTest_TestResult
DllInitialized                                              byte
	CODE
	clear(q)
	if ~self.DllMgr &= null
		DllInitialized = self.DllMgr.IsInitialized()
		if DllInitialized = true
			self.DllMgr.kill()
		end
		free(self.Procedures)
		if self.DllMgr.GetExportedProcedures(self.Dllname,procsq) = Level:Benign
			! Look for the CLARIONTEST_GETLISTOFTESTPROCEDURES procedure
			loop x = 1 to records(procsq)
				get(procsq,x)
				!dbg.Write('>' & upper(left(clip(procsq.ProcName))) & '<<')
				if upper(sub(left(procsq.procname),1,len(GetListproc))) = GetListProc
					! Get the list of procedures from that method
					dbg.write('************** found ' & GetListProc & ' *************')
					ListProcedureFound = TRUE
					BREAK
				END
				if upper(sub(procsq.ProcName,1,5)) = 'TEST_'
					self.Procedures.testname = procsq.ProcName
					add(self.Procedures,self.Procedures.testname)
					dbg.write('ClarionTest_TestRunner.GetTestProcedures added test procedure ' & q)
				end				
			end
			if ListProcedureFound
				! Discard any previously found procedures and get the definitive list
				self.DllMgr.Kill()
				if self.DllMgr.Init(self.DllName) = Level:Benign
					dbg.write('calling ' & GetListProc & ' with address(lptr) ' & address(lptr))
					r# = self.DllMgr.Call(GetListProc,address(lptr))
					dbg.write('return value: ' & r#)
				end
				dbg.write('lptr ' & lptr)
				ctProcedures &= (lptr)
				!utr &= (lptr)
				!dbg.write('utr.Message: ' & utr.Message)
				if ~ctProcedures &= null 
					dbg.write('ctProcedures is not null')
					!dbg.write('ctProcedures.Names: ' & ctProcedures.Names[1])
					dbg.write(records(ctProcedures.List) & ' records found')
					free(q)
					loop x = 1 to records(ctProcedures.List)
						get(ctProcedures.List,x)
						self.Procedures.testname = ctProcedures.List.testname
						add(self.Procedures,self.Procedures.testname)
						dbg.write('Added test procedure to self.procedures: ' & self.Procedures.testname)
					END
				end
			end
		end
		free(q)
		loop x = 1 to records(self.Procedures)
			get(self.Procedures,x)
			q = self.Procedures.testname
			add(q)
			dbg.write('Added procedure ' & q)
		END
		if DllInitialized = true and self.DllMgr.IsInitialized() = FALSE
			self.DllMgr.Init(self.dllname)
		end
	end
	
	
ClarionTest_TestRunner.RunTest                         procedure(long index)!,ClarionTest_TestResult	
result	&ClarionTest_TestResult
lptr	long
	code
	if self.DllMgr &= NULL or self.DllMgr.IsInitialized() = false
		return self.GetFailedTest('The DLL was not initialized')
	end
	dbg.write('ClarionTest_TestRunner.RunTest: ' & records(self.Procedures) & ' records in self.procedures')
	get(self.Procedures,index)
	if errorcode()
		return self.GetFailedTest('Could not find the requested test (index ' & index & ') ' & error())
	end
	r# = self.DllMgr.Call(upper(clip(self.Procedures.testname)),address(lptr))
	if r# <> 0
		return self.GetFailedTest('Could not execute the test: ' & self.DllMgr.ErrorStr)
	END
	result &= (lptr)
	return result

ClarionTest_TestRunner.GetFailedTest                         procedure(string errormsg)
result	&ClarionTest_TestResult
	CODE
	result &= new ClarionTest_TestResult
	result.passed = FALSE
	result.Message = errormsg
	return result
	